﻿using System.Collections;
using Microsoft.TeamFoundation.WorkItemTracking.Client;

namespace Goshoom.DynamicsAX.TFS.WorkItems
{
    public class QueryDefinitionAdapter : QueryItemAdapter
    {
        #region Fields
        private QueryDefinition queryDefinition;
        private Query query;
        #endregion

        #region Properties
        protected override QueryItem QueryItem
        {
            get { return queryDefinition; }
        }
        internal override bool AllowAddToTree
        {
            get { return queryDefinition.QueryType == QueryType.List; }
        }
        public override bool IsFolder
        {
            get { return false; }
        }
        public ArrayList Fields
        {
            get { return new ArrayList(Query.DisplayFieldList); }
        }
        private Query Query
        {
            get
            {
                if (query == null)
                {
                    query = new Query(
                        queryDefinition.Project.Store,
                        queryDefinition.QueryText,
                        QueryContext);
                }
                return query;
            }
        }
        protected IDictionary QueryContext
        {
            get
            {
                Hashtable context = new Hashtable();
                context.Add("project", queryDefinition.Project.Name);
                return context;
            }
        }
        #endregion

        #region Constructors
        public QueryDefinitionAdapter(QueryItem queryItem)
            : base(queryItem)
        {
            queryDefinition = (QueryDefinition)queryItem;
        }
        #endregion

        #region Methods
        public static QueryDefinitionAdapter castFromQueryItem(QueryItemAdapter _itemToCast)
        {
            return (QueryDefinitionAdapter)_itemToCast;
        }
        public WorkItemCollection ExecuteQuery()
        {
            return this.Query.RunQuery();
        }
        #endregion
    }
}
