﻿using System.Collections;
using Microsoft.TeamFoundation.WorkItemTracking.Client;

namespace Goshoom.DynamicsAX.TFS.WorkItems
{
    public class QueryFolderAdapter : QueryItemAdapter
    {
        private QueryFolder queryFolder;

        protected override QueryItem QueryItem
        {
            get { return queryFolder; }
        }
        public bool HasChildren
        {
            get { return queryFolder.Count != 0; }
        }
        public override bool IsFolder
        {
            get { return true; }
        }
        internal override bool AllowAddToTree
        {
            get { return HasChildren; }
        }

        public QueryFolderAdapter(QueryItem queryItem)
            : base(queryItem)
        {
            queryFolder = (QueryFolder)queryItem;
        }

        public static QueryFolderAdapter castFromQueryItem(QueryItemAdapter _itemToCast)
        {
            return (QueryFolderAdapter)_itemToCast;
        }        
        public ArrayList GetChildren()
        {
            IEnumerator enumerator = ((IEnumerable)queryFolder).GetEnumerator();
            ArrayList children = new ArrayList();

            while (enumerator.MoveNext())
            {
                QueryItemAdapter queryNode = QueryItemAdapter.NewFromQueryItem((QueryItem)enumerator.Current);
                if (queryNode.AllowAddToTree)
                {
                    children.Add(queryNode);
                }
            }
            return children;
        }
    }
}
