﻿using System;
using Microsoft.TeamFoundation.WorkItemTracking.Client;

namespace Goshoom.DynamicsAX.TFS.WorkItems
{
    abstract public class QueryItemAdapter
    {
        #region Properties
        protected abstract QueryItem QueryItem { get; }
        public string Name
        {
            get { return QueryItem.Name; }
        }
        abstract public bool IsFolder {get;}
        /// <summary>
        /// Whether this item can be added to query tree hierarchy, e.g. if it is supported in AX.
        /// </summary>
        abstract internal bool AllowAddToTree{get;}
        public Guid Id
        {
            get { return QueryItem.Id; }
        }
        #endregion 

        public QueryItemAdapter(QueryItem queryItem)
        {
        }
        public static QueryItemAdapter NewFromQueryItem(QueryItem queryItem)
        {
            if (queryItem == null)
            {
                throw new ArgumentNullException("queryItem");
            }
            if (queryItem is QueryFolder)
            {
                return new QueryFolderAdapter(queryItem);
            }
            else if (queryItem is QueryDefinition)
            {
                return new QueryDefinitionAdapter(queryItem);
            }
            else
            {
                throw new ArgumentException(String.Format("{Type {0} is not supported here.", typeof(QueryItem)));
            }

        }
    }
}
